/* 	SOMNode.java
	ISC234 Midterm 2011
	Name:
	Precept:
	Compile instructions:
	Descriptions:
	
*/

import java.util.Iterator;

public class SOMNode{
	
	private Queue<Gene> geneList;
	private int x,y;
	private double[] weight_vector;
	
	public SOMNode(int x, int y, int vector_size){
		//allocates memory for geneList and weight_vector,
		//sets x and y coordinates
		this.x = x;
		this.y = y;
		weight_vector = new double[vector_size];
		geneList = new Queue<Gene>();
	}
	
	public void set_weight_vector(double[] weight_vector){
		this.weight_vector = weight_vector;
	}
	
	public double[] get_weight_vector(){
		return this.weight_vector;
	}
	
	public void add_gene(Gene g){
		//adds the gene g to the end of the geneList
		geneList.enqueue(g);
	}
	
	public Queue<Gene> get_geneList(){
		return geneList;
	}
	
	//removes all genes in the geneList
	public void clear_geneList(){
		while(!geneList.isEmpty()){
			geneList.dequeue();
		}
	}
	
	//for debugging purposes
	public String toString(){
		String s = "";
		s += "Node " + x + " " + y + "\nweight vector: ";
		for(int i=0; i<weight_vector.length; i++){
			s += String.format("%.2f", weight_vector[i]) + " ";
		}
		s += "\nGenes:\n";
		
		Iterator<Gene> it = geneList.iterator();
		int c = 0;
		while(it.hasNext()){
			if(c%5==0 && c!=0){
				s += "\n";
			}
			s += it.next() + " ";
			c++;
		}
		s += "\n";
		return s;
	}
	
	public int get_x(){
		return this.x;
	}
	
	public int get_y(){
		return this.y;
	}
	
}
