import java.util.Random;

public class TestBMU{

	public static void main(String[] args){
	
		Random rand = new Random(100);
	
		double[] v1 = {184, 188, 49};
		double[] v2 = {183, 170, 7};
		double[] v3 = {199, 77, 158};

								
		Gene[] genes = new Gene[5];
		genes[0] = new Gene("g1", v1);
		genes[1] = new Gene("g2", v2);
		genes[2] = new Gene("g3", v3);

		
		int M = 3;
		int N = 2;
		int NUM_ITERATIONS = 100;
		double INITIAL_LEARNING_RATE = 0.1;
		SOM som = new SOM(genes, M, N, NUM_ITERATIONS, INITIAL_LEARNING_RATE);

		SOMNode[] map = som.get_map();
		set_value(117, 163, 245, map[0].get_weight_vector());
		set_value(179, 159, 63, map[1].get_weight_vector());
		set_value(60, 68, 124, map[2].get_weight_vector());
		set_value(27, 174, 207, map[3].get_weight_vector());
		set_value(134, 73, 127, map[4].get_weight_vector());
		set_value(106, 253, 129, map[5].get_weight_vector());
		
		Gene g1 = genes[0];
		Gene g2 = genes[1];		
		Gene g3 = genes[2];

		SOMNode n1 = som.find_best_matching_unit(g1);
		SOMNode n2 = som.find_best_matching_unit(g2);
		SOMNode n3 = som.find_best_matching_unit(g3);

		System.out.printf("The BMU for Gene %s %s is Node (%d %d)\n", g1.getName(),
			g1.getValues_str(), n1.get_x(), n1.get_y());
		System.out.printf("The BMU for Gene %s %s is Node (%d %d)\n", g2.getName(),
			g2.getValues_str(), n2.get_x(), n2.get_y());
		System.out.printf("The BMU for Gene %s %s is Node (%d %d)\n", g3.getName(),
			g3.getValues_str(), n3.get_x(), n3.get_y());
		
		
		
	
	}
	
	public static void set_value(int a, int b, int c, double[] d){
		d[0] = a;
		d[1] = b;
		d[2] = c;
	}
	
		
}
		
