public class TestFunction{

	public static void main(String[] args){
	
		System.out.println("====TEST 1 EUCLIDEAN DISTANCE====\n");
		double[] d1 = {2.0, 3.0, 4.0};
		double[] d2 = {4.0, 5.0, 6.0};
		System.out.println("Given points: (2.0, 3.0, 4.0) (4.0, 5.0, 6.0)");
		System.out.printf("Euclidean distance: %.2f\n", 
			Distance.euclidean_distance(d1, d2));
		System.out.println();

		System.out.println("====TEST 2 NEIGHBORHOOD RADIUS====\n");
		double INITIAL_RADIUS = 5.0;
		double RADIUS_DECAY = 0.995;
		System.out.printf("Given INITIAL_RADIUS = %.3f, RADIUS_DECAY = %.3f"+"\n", 
			INITIAL_RADIUS, RADIUS_DECAY);
		System.out.printf("neighborhood radius at t=0: %.2f\n", 
			Function.calculate_neighborhood_radius(0, INITIAL_RADIUS, RADIUS_DECAY));
		System.out.printf("neighborhood radius at t=1: %.2f\n", 
			Function.calculate_neighborhood_radius(1, INITIAL_RADIUS, RADIUS_DECAY));
		System.out.println();

		System.out.println("====TEST 3 INFLUENCE FUNCTION====\n");
		SOMNode bmu = new SOMNode(2, 3, 3);
		SOMNode node_i = new SOMNode(2, 5, 3);
		SOMNode node_j = new SOMNode(2, 10, 3);
		System.out.printf("Given 3 nodes and their coordinates: \n" +
			"bmu (%d, %d), node_i (%d %d), node_j (%d %d)\n", 2, 3, 2, 5, 2, 10); 
		System.out.printf("Given the same INITIAL_RADIUS, RADIUS_DECAY settings as in TEST 2\n\n");
		System.out.println("Using a hypothetical neighborhood radius of 10.0. ");
		System.out.println("Influence function: ");
		System.out.println("Between bmu and node_i: influence = " +
			Function.calculate_influence(bmu, node_i, 10.0));
		System.out.println("Between bmu and node_j: influence = " +
			Function.calculate_influence(bmu, node_j, 10.0));
		System.out.println();

		double radius = Function.calculate_neighborhood_radius(0, INITIAL_RADIUS, RADIUS_DECAY); 
		System.out.printf("Using a calculated neighborhood radius (at t=0) of %.2f\n", 
			radius);
		System.out.println("Influence function: ");
		System.out.println("Between bmu and node_i: influence = " +
			Function.calculate_influence(bmu, node_i, radius));
		System.out.println("Between bmu and node_j: influence = " +
			Function.calculate_influence(bmu, node_j, radius));
		System.out.println();

		radius = Function.calculate_neighborhood_radius(1, INITIAL_RADIUS, RADIUS_DECAY); 
		System.out.printf("Using a calculated neighborhood radius (at t=1) of %.2f\n",
			radius);
		System.out.println("Influence function: ");
		System.out.println("Between bmu and node_i: influence = " +
			Function.calculate_influence(bmu, node_i, radius));
		System.out.println("Between bmu and node_j: influence = " +
			Function.calculate_influence(bmu, node_j, radius));
		System.out.println();

		System.out.println("====TEST 4 LEARNING RATE====\n");
		double INITIAL_LEARNING_RATE = 0.1;
		double NUM_ITERATIONS = 1000;
		System.out.printf("Given INITIAL_LEARNING_RATE = %.2f NUM_ITERATIONS = %.0f\n", 
			INITIAL_LEARNING_RATE, NUM_ITERATIONS);
		System.out.printf("Learning rate at t=0: %.2f\n", 
			Function.calculate_n(0, INITIAL_LEARNING_RATE, NUM_ITERATIONS));
		System.out.printf("Learning rate at t=500: %.2f\n", 
			Function.calculate_n(500, INITIAL_LEARNING_RATE, NUM_ITERATIONS));
		System.out.println();

		System.out.println("====TEST 5 WEIGHT UPDATE====\n");
		System.out.printf("Given: influence = %.2f, learning = %.2f, ", 1.0, 0.1);
		System.out.printf("weight vector=(%.1f %.1f %.1f), sample vector=(%d %d %d)\n", 5.0,3.0,0.0, 1,2,3);
		double[] w = {5.0, 3.0, 0.0};
		double[] s = {1, 2, 3};
		double[] dd = Function.update_weight_vector(0.1, 1.0, s, w);
		System.out.printf("new weight=(%.2f %.2f %.2f)\n", 
			dd[0], dd[1], dd[2]);

	}
}
