import java.util.Random;

public class TestOneIteration{

	public static void main(String[] args){
	
		Gene[] genes = TestSOM.read_dataset("color.pcl");
		int M = 3;
		int N = 2;
		int NUM_ITERATIONS = 100;
		double INITIAL_LEARNING_RATE = 0.1;
		SOM som = new SOM(genes, M, N, NUM_ITERATIONS, INITIAL_LEARNING_RATE);
	
		SOMNode[] map = som.get_map();
		
		Random rand = new Random(100);
		
		//initializes weight vectors to random values
		for(int i=0; i<map.length; i++){
			double[] weight_vector = map[i].get_weight_vector();
			for(int j=0; j<weight_vector.length; j++){
				weight_vector[j] = (double) (rand.nextInt(256));
			}
			map[i].set_weight_vector(weight_vector);
		}	
		
		
		System.out.println("=======  INITIAL  ========");
		System.out.println(som);			
		som.do_cluster_one_iteration(0);
		
		System.out.println("=======  AFTER t=0  ========");
		System.out.println(som);	
		
		som.do_cluster_one_iteration(1);
		System.out.println("=======  AFTER t=1  ========");
		System.out.println(som);	
		
		System.out.println("... ... ... ... ... ... ... ...\n\n");
		
		for(int i=2; i<NUM_ITERATIONS; i++){
			som.do_cluster_one_iteration(i);
		}
		System.out.println("=======  AFTER t=100  ========");
		System.out.println(som);
		
	}

}